module std.c.posix.sys.stat;

private import std.c.stdint;
private import std.c.config;
public import std.c.stddef; // for size_t
public import std.c.posix.sys.types; // for off_t, mode_t

version (darwin)
{
    struct struct_stat
    {
        dev_t       st_dev;
        ino_t       st_ino;
        mode_t      st_mode;
        nlink_t     st_nlink;
        uid_t       st_uid;
        gid_t       st_gid;
        dev_t       st_rdev;
        time_t      st_atime;
        c_ulong     st_atimensec;
        time_t      st_mtime;
        c_ulong     st_mtimensec;
        time_t      st_ctime;
        c_ulong     st_ctimensec;
        off_t       st_size;
        blkcnt_t    st_blocks;
        blksize_t   st_blksize;
        uint        st_flags;
        uint        st_gen;
        int         st_lspare;
        long        st_qspare[2];
    }

    /* XSI */
    const auto S_IFMT   =   0170000;
    const auto S_IFIFO  =   0010000;
    const auto S_IFCHR  =   0020000;
    const auto S_IFDIR  =   0040000;
    const auto S_IFBLK  =   0060000;
    const auto S_IFREG  =   0100000;
    const auto S_IFLNK  =   0120000;
    const auto S_IFSOCK =   0140000;
    }
}